
/////////////////////////////////////////////////////////////////////////
//
// CD-TEXT decoding routine (CdText.h)
//
//   Copyright (C) 2002 Takabin (Bin Takanami)
//   This file is NOT under GPL, you can use it freely at your own risk.
//
/////////////////////////////////////////////////////////////////////////

#ifndef CdTextH
#define CdTextH
//---------------------------------------------------------------------------

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//2̒`͕ύX\
#define MAX_NUM_LANG_BLOCKS 8                    //1, 2, ... 8܂
#define MAX_NUM_PACKETS     14                   //egbNɊ蓖ĂőpPbg
                                                 //14 * 12 = 168
                                                 //e160BytesȓȂ̂
//---------------------------------------------------------------------------

#define BLOCK_DATA_SIZE  12
#define MAX_TEXT         BLOCK_DATA_SIZE*MAX_NUM_PACKETS

#pragma pack(push, 1)
enum ctTypes{
	ctTitle	      = 0x80,
	ctPerformer	  = 0x81,
	ctSongwriter  = 0x82,
	ctComposer	  = 0x83,
	ctArranger	  = 0x84,
	ctMessage	  = 0x85,
	ctIdentifier  = 0x86,
	ctGenre		  = 0x87,

	ctToc         = 0x88,
	ctToc2        = 0x89,
	ctUnknownA	  = 0x8A,
	ctUnknownB	  = 0x8B,
	ctUnknownC	  = 0x8C,
	ctReserved	  = 0x8D,
	ctMCNorISRC	  = 0x8E, // MCN/ISRC
	ctSizeInfo	  = 0x8F  // ef[^̃ubNȂ
};

enum CdTextGenres{
    cgNotUsed          = 0x00,
    cgUndefined        = 0x01,
    cgAdultContemp     = 0x02,
    cgAlternativeRock  = 0x03,
    cgChildrens        = 0x04,
    cgClassical        = 0x05,
    cgContempChristian = 0x06,
    cgCountry          = 0x07,
    cgDance            = 0x08,
    cgEasyListening    = 0x09,
    cgErotic           = 0x0A,
    cgFolk             = 0x0B,
    cgGospel           = 0x0C,
    cgHiphop           = 0x0D,
    cgJazz             = 0x0E,
    cgLatin            = 0x0F,
    cgMusical          = 0x10,
    cgNewage           = 0x11,
    cgOpera            = 0x12,
    cgOperetta         = 0x13,
    cgPop              = 0x14,
    cgRap              = 0x15,
    cgReggae           = 0x16,
    cgRock             = 0x17,
    cgRythmEffects     = 0x18,
    cgSoundsEffects    = 0x19,
    cgSoundtrack       = 0x1A,
    cgSpokenWord       = 0x1B,
    cgWorldMusic       = 0x1C
};

enum CdTextCharsets{
    ccISO8859 = 0x00,
    ccASCII   = 0x01,
    ccMS_JIS  = 0x80
};

enum CdTextLanguages{
    clNotUsed    = 0x00,
    clCzech      = 0x06,
    clDanish     = 0x07,
    clGerman     = 0x08,
    clEnglish    = 0x09,
    clSpanish    = 0x0A,
    clFrench     = 0x0F,
    clItailian   = 0x15,
    clHungarian  = 0x1B,
    clDutch      = 0x1D,
    clNorwegian  = 0x1E,
    clPolish     = 0x20,
    clPortuguese = 0x21,
    clSlovene    = 0x26,
    clFinnish    = 0x27,
    clSwedish    = 0x28,
    clTurkish    = 0x29,
    clRussian    = 0x56,
    clKorean     = 0x65,
    clJapanese   = 0x69,
    clGreek      = 0x70,
    clChinese    = 0x75,
};
//---------------------------------------------------------------------------

struct TCdTextPacket{

    BYTE mType;
    BYTE mTrackNo;
    BYTE mIndexInLang;      // ubNł̐擪̒ʂԍ

    BYTE mPosInTrack   :4;  // 擪̃gbNł̐擪̕ʒui2oCgȂ炻̕j
    BYTE mLangIndex    :3;  // ubÑCfbNX(擪̌=0, 2nd=1 .... 8th=7)
    BYTE mIs2ByteChar  :1;  // 0=Single byte, 1=double byte

    BYTE mData[12];
    BYTE mCRC0;
    BYTE mCRC1;
};

struct SizeInfo1{

    BYTE mCharset;      // 0x00 = ISO8859, 0x01 = ASCII, 0x80 = MS-JIS
    BYTE mFirstTrack;  
    BYTE mLastTrack;
    BYTE mFlags;        // 2bitsCopy protection
                        // protected = 0x03, permited = 0x00

    BYTE mTitle;        // ẽpPbg
    BYTE mPerformer;
    BYTE mSongwriter;
    BYTE mComposer;

    BYTE mArranger;
    BYTE mMessage;
    BYTE mIdentifier;
    BYTE mGenre;
};

struct SizeInfo2{
    BYTE mToc;
    BYTE mToc2;
    BYTE mUnknown2;     // Type = 0x8A
    BYTE mUnknown3;     //        0x8B

    BYTE mUnknown4;     //        0x8C
    BYTE mReserved;
    BYTE mMCNorISRC;
    BYTE mSizeInfo;     // 0x03O

    BYTE mNumPackets1;  // ẽpPbg-1
    BYTE mNumPackets2;
    BYTE mNumPackets3;  // 3ȍ~͗\
    BYTE mNumPackets4;
};

struct SizeInfo3{
    BYTE mNumPackets5;
    BYTE mNumPackets6;
    BYTE mNumPackets7;
    BYTE mNumPackets8;

    BYTE mLangage1;     // eubŇR[h
    BYTE mLangage2;     //   English = 0x09, Japanese = 0x69 etc.
    BYTE mLangage3;     // 3ȍ~͗\
    BYTE mLangage4;

    BYTE mLangage5;
    BYTE mLangage6;
    BYTE mLangage7;
    BYTE mLangage8;
};

//---------------------------------------------------------------------------

struct TCdTextLangBlock{
    CdTextLanguages mLanguage;
    CdTextCharsets  mCharset;

    int mFirstTrack;
    int mLastTrack;

    bool mCopyProtected;

    int mGenre;
    char mGenreStr[MAX_TEXT];
    char mIndentifier[MAX_TEXT];

    char mTitle[100][MAX_TEXT];
    char mPerformer[100][MAX_TEXT];
    char mSongwriter[100][MAX_TEXT];
    char mComposer[100][MAX_TEXT];
    char mArranger[100][MAX_TEXT];
    char mMessage[100][MAX_TEXT];
    char mMCNorISRC[100][MAX_TEXT];
};

struct CdTextDisc{
    TCdTextLangBlock mLangBlocks[MAX_NUM_LANG_BLOCKS];
    int mNumLangBlocks;
};

#pragma pack(pop)

//---------------------------------------------------------------------------

bool DecodeCdText(TCdTextPacket* inTextBlocks, int inNumBlocks, CdTextDisc *outTextInfo);
//---------------------------------------------------------------------------

#endif
